import java.io.*;

public class Ref {
    private byte[] s = null;
    private int n = 0;
    private final int maxn = 1<<20;
    Ref() {
        s = new byte[maxn];
    }
    /**
     * Reads the entire input from stdin (until EOF) into s.
     */
    public void readAll(InputStream in) throws IOException {
        int rv;
        while (true) {
            if (n+4096 > maxn)
                throw new Error("Input too long");
            rv = in.read(s, n, 4096);
            if (rv < 0)
                return;
            n += rv;
        }
    }
    /**
     * Writes s[i..i+k-1] to stdout.
     */
    public void writeSubstr(int i, int k) {
        System.out.write(s, i, k);
    }
    /**
     * Write a blank line to stderr.
     * This makes it easier to run the program from the command
     * line and view the output.
     * NOTE: Don't add any newlines to stdout;
     * otherwise, the program will fail the auto-grading tests!!
     */
    public void blankLine() {
        System.err.println();
    }
    /**
     * Finds the longest substring that is repeated in stdin.
     */
    public void go() throws IOException {
        int i, j, k, l, besti, bestk;

        readAll(System.in);

        // Naive algorithm to find the longest substring that's repeated in S
        bestk = 0; besti = 0;
        for (i=0; i<n; i++)
            for (j=i+1; j<n; j++)
                for (k=1; k<n-j+1; k++) {
                    for (l=0; l<k; l++) {
                        if (s[i+l] != s[j+l])
                            break;
                    }
                    if (l == k && k > bestk) {
                        bestk = k; besti = i;
                    }
                }

        writeSubstr(besti, bestk);
        blankLine();
    }
    public static void main(String[] args) throws IOException {
        Ref r = new Ref();
        r.go();
    }
}
